#ifndef __CONTO_H
#define __CONTO_H

#ifndef __STRINGS_H
#include <strings.h>
#endif

#ifndef __REAL_H
#include <real.h>
#endif

class TBill : public TSortable
{
  char _tipo;              // ' ' = Conto, 'C' = Cliente, 'F' = 'Fornitore'
  int _gruppo, _conto;
  long _sottoconto;        // Sottoconto, codice cliente o fornitore
  TString80 _descrizione;  // Vuota fino alla chiamata di describe
  int _tipo_cr;            // Tipo costo/ricavo
  bool _sospeso;
  
protected:
  virtual int compare(const TSortable& s) const;
  virtual const char* class_name() const { return "Conto"; }
  void describe();
  
  const TBill& copy(const TBill& b);

public:
  TBill(int g = 0, int c = 0, long s = 0L, char t = ' ', const char* d = NULL, int r = -1)
    : _tipo(t), _gruppo(g), _conto(c), _sottoconto(s), _descrizione(d), _tipo_cr(r) { set(g,c,s,t,d,r);}

  TBill(TToken_string& tgcsd, int from, int mode = 0);
  TBill(const TBill& b) { copy(b); }
  virtual ~TBill() {}

  const TBill& set(int g = 0, int c = 0, long s = 0L, char t = ' ', 
                   const char* d = NULL, int r = -1);
  const TBill& add_to(TToken_string& ts, int from, int mode = 0);
  const TBill& operator=(const TBill& b) { return copy(b); }

  virtual bool ok() const;        // Gruppo, Conto e Sottoconto non nulli
  bool empty() const { return _gruppo==0 && _conto==0 && _sottoconto == 0; }

  char tipo() const { return _tipo; }
  int gruppo() const { return _gruppo; }
  int conto() const { return _conto; }
  long sottoconto() const { return _sottoconto; }
  
  const TString& descrizione();
  int tipo_cr();
  void tipo_cr(int tcr) { _tipo_cr = tcr; }
  
  int tipo_att();
  bool read(TRectype& r);
  bool sospeso() const { return _sospeso;}  // _sospeso e' letto nella read()
  
  const char* string(int mode = 0);
};


enum TIndbil { ib_null, ib_attivita, ib_passivita, ib_costi, ib_ricavi, ib_conti_ordine };

class TConto : public TBill
{
  real _dare, _avere, _darepro, _averepro, _saldo;

public:
  TConto(int g = 0, int c = 0, long s = 0L, char t = ' ', const char* d = NULL)
    : TBill(g, c, s, t, d) {}
  TConto (TToken_string& tgcsd, int from, int mode = 0)
    : TBill(tgcsd, from, mode) {};
  
  real& dare() { return _dare; }
  real& avere() { return _avere; }
  real& darepro() { return _darepro; }
  real& averepro() { return _averepro; }
  real& saldo()  { return _saldo; }
};

#endif




